---
title: Document.adoptNode()
slug: Web/API/Document/adoptNode
tags:
  - API
  - DOM
  - DOM Reference
  - Method
  - NeedsExample
  - NeedsSpecTable
  - NeedsUpdate
  - Reference
---
<div>{{ ApiRef("DOM") }}</div>

<p><strong><code>Document.adoptNode()</code></strong> transfers a {{Glossary("node/dom", "node")}} from another {{domxref("Document", "document", "", "1")}} into the method's document. The adopted node and its subtree is removed from its original document (if any), and its {{domxref("Node.ownerDocument", "ownerDocument")}} is changed to the current document. The node can then be inserted into the current document.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>importedNode</var> = document.adoptNode(<var>externalNode</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>externalNode</var></code></dt>
 <dd>The node from another document to be adopted.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The copied <code><var>importedNode</var></code> in the scope of the importing document. </p>

<p>After calling this method, <code><var>importedNode</var></code> and <code><var>externalNode</var></code> are the same object.</p>

<div class="notecard note">
<p><strong>Note:</strong> <code><var>importedNode</var></code>'s {{domxref("Node.parentNode")}} is <code>null</code>, since it has not yet been inserted into the document tree!</p>
</div>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">const iframe = document.querySelector('iframe');
const iframeImages = iframe.contentDocument.querySelectorAll('img');
const newParent = document.getElementById('images');

iframeImages.forEach(function(imgEl) {
  newParent.appendChild(document.adoptNode(imgEl));
});
</pre>

<h2 id="Notes">Notes</h2>

<p>Before they can be inserted into the current document, nodes from external documents should either be:</p>

<ul>
 <li>cloned using {{domXref("document.importNode()")}}; or</li>
 <li>adopted using {{domXref("document.adoptNode()")}}.</li>
</ul>

<div class="notecard note">
<p><strong>Best Practice:</strong> Although Firefox doesn't currently enforce this rule, we encourage you to follow this rule for improved future compatibility.</p>
</div>

<p>For more on the {{domXref("Node.ownerDocument")}} issues, see the W3C DOM FAQ.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-document-adoptnode', 'document.adoptNode')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.adoptNode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("document.importNode()")}}</li>
</ul>
